/**
*	ut.c
*	Tu[`W
*	Copyright (c)2005 Junnichi Tomaru
*/
#include	<stdlib.h>
#include	<ctype.h>
#include	<string.h>
#include	"ut.h"

const char	hexnum[] = "0123456789ABCDEF";


/**
*	lPOi(unsigned char,[TvXȂ)
*	 in	num:f[^
*		buf:i[敶
*	out	obt@|C^
*/
char	*uctoa( byte num, char *buf )
{
	*( buf + 0 ) = ( num / 100 ) + 0x30;
	num %= 100;
	*( buf + 1 ) = ( num / 10 ) + 0x30;
	*( buf + 2 ) = ( num % 10 ) + 0x30;
	*( buf + 3 ) = '\0';

	return	buf;
}


/**
*	lPUi(unsigned char)
*	 in	num:f[^
*		buf:i[敶
*	out	obt@|C^
*/
char	*uctoahz( byte num, char *buf )
{
	nbl_t	nb;

	nb.data = num;
	*( buf + 0 ) = hexnum[nb.nbl.hi];
	*( buf + 1 ) = hexnum[nb.nbl.lo];
	*( buf + 2 ) = '\0';

	return	buf;
}


/**
*	lQPOi(unsigned char)
*	 in	num:f[^
*		buf:i[敶
*	out	obt@|C^
*/
char	*uctoa2( byte num, char *buf )
{
	*( buf + 0 ) = ( num / 10 ) + 0x30;
	*( buf + 1 ) = ( num % 10 ) + 0x30;
	*( buf + 2 ) = '\0';

	return	buf;
}


/**
*	AXL[(unsigned short,[TvX)
*	 in	num:f[^
*		buf:i[敶
*	out	obt@|C^
*/
char	*utoa( word num, char *buf )
{
	word	n;
	int	i, f;
	char	*p;

	p = buf;
	for( n = 10000U, f = 0; n > 1; n /= 10 ){
		i = num / n;
		num %= n;
		if(( f == 0 ) && ( i != 0 )){
			f = 1;
		}
		if( f == 1 ){
			*p = ( char )( i + 0x30 );
			p++;
		}
	}
	*p = num + 0x30;
	*( p + 1 ) = '\0';

	return	buf;
}


/**
*	lPOi(unsigned short,[TvXȂ)
*	 in	num:f[^
*		buf:i[敶
*	out	obt@|C^
*/
char	*utoa3( word num, char *buf )
{
	*( buf + 0 ) = ( num / 100 ) + 0x30;
	num %= 100;
	*( buf + 1 ) = ( num / 10 ) + 0x30;
	*( buf + 2 ) = ( num % 10 ) + 0x30;
	*( buf + 3 ) = '\0';

	return	buf;
}


/**
*	lPUi(unsigned long)
*	code:130bytes
*	 in	num:f[^
*		buf:i[敶
*	out	obt@|C^
*/
char	*ultoahz( dword num, char *buf )
{
	nbll_t	nb;

	nb.data = num;
	buf[0] = hexnum[nb.nbl.hhh];
	buf[1] = hexnum[nb.nbl.hhl];
	buf[2] = hexnum[nb.nbl.hlh];
	buf[3] = hexnum[nb.nbl.hll];
	buf[4] = hexnum[nb.nbl.lhh];
	buf[5] = hexnum[nb.nbl.lhl];
	buf[6] = hexnum[nb.nbl.llh];
	buf[7] = hexnum[nb.nbl.lll];
	buf[8] = '\0';

	return	buf;
}


/**
*	POi𐔒l
*	 in	ϊ
*	out	ϊf[^
*/
byte	atod( char *buf )
{
	char	c, d;

	c = *( buf + 0 ) - '0';
	d = *( buf + 1 ) - '0';

	return	c * 10 + d;
}


/**
*	PUi𐔒l
*	 in	ϊ
*	out	ϊf[^
*/
byte	atox( char *buf )
{
	char	c, d;
	nbl_t	ret;

	c = toupper( *buf );
	if(( c >= '0' ) && ( c <= '9' )){
		d = c - '0';
	}
	else if(( c >= 'A' ) && ( c <= 'F' )){
		d = c - 'A' + 10;
	}
	ret.nbl.hi = d;
	c = toupper( *( buf + 1 ));
	if(( c >= '0' ) && ( c <= '9' )){
		d = c - '0';
	}
	else if(( c >= 'A' ) && ( c <= 'F' )){
		d = c - 'A' + 10;
	}
	ret.nbl.lo = d;

	return	ret.data;
}


/**
*	hoAhX𕶎ɂ(RŒ)
*	 in	ipadr:hoAhX
*		  buf:i[敶
*	out	obt@|C^
*/
char	*long2ipstr( dword ipadr, char *buf )
{
	ul_t	tmp;

	tmp.data = ipadr;
	uctoa( tmp.bytes.hh, buf );
	buf[3] ='.';
	uctoa( tmp.bytes.hl, buf + 4 );
	buf[7] ='.';
	uctoa( tmp.bytes.lh, buf + 8 );
	buf[11] ='.';
	uctoa( tmp.bytes.ll, buf + 12 );

	return	buf;
}


/**
*	ipAhXlong^ɕϊ
*	 in	adrstr	hoAhX
*		ɐƃhbgȊO܂ނƂ͂łȂ
*	out	ϊ̃AhX
*		"192.168.0.100" -> 0xc0a80064
*		G[̏ꍇ0x00000000Ԃ
*/
dword	ipstr2bin( char *adrstr )
{
	char	*p, *q, tmp[32];
	int	i;
	dword	ret;

	ret = 0;
	strcpy( tmp, adrstr );
	p = q = tmp;
	for( i = 0; i < 16; i++, q++ ){
		if( *q == '.' ){
			*q = '\0';
			ret |= atol( p );
			ret <<= 8;
			p = q + 1;
		}
		else if( *q == '\0' ){
			*q = '\0';
			ret |= atol( p );
			break;
		}
		else if( isdigit( *q ) == 0 ){
			ret = 0;
			break;
		}
	}
	return	ret;
}


/* end of ut.c */
